﻿using Hotline.Share.Dtos.Knowledge;
using Hotline.Share.Dtos.Order;
using Mapster;
using Sharing.DaoShu110.Dtos;
using Sharing.Province.HuiJu.Send;
using Sharing.Province.XieTong.Knowledge;

namespace Sharing.Application.Mappers
{
    public class MapperConfigs : IRegister
    {
        public void Register(TypeAdapterConfig config)
        {
            config.ForType<KnowledgeSendDto, GetKnowledgeInfoSend>()
            .Map(d => d.CreatDate, x => x.CreatDate == null ? null : x.CreatDate.Value.ToString("yyyy-MM-dd HH:mm:ss"))
            .Map(d => d.BeginDate, x => x.BeginDate == null ? null : x.BeginDate.Value.ToString("yyyy-MM-dd HH:mm:ss"))
            .Map(d => d.DisableDate, x => x.DisableDate == null ? null : x.DisableDate.Value.ToString("yyyy-MM-dd HH:mm:ss"))
          ;

            config.ForType<GetKnowledgeInfoUpdate, GetKnowledgeInfoSend>()
            .Map(d => d.CreatDate, x => x.CreatDate == null ? null : x.CreatDate.Value.ToString("yyyy-MM-dd HH:mm:ss"))
            .Map(d => d.BeginDate, x => x.BeginDate == null ? null : x.BeginDate.Value.ToString("yyyy-MM-dd HH:mm:ss"))
            .Map(d => d.DisableDate, x => x.DisableDate == null ? null : x.DisableDate.Value.ToString("yyyy-MM-dd HH:mm:ss"))
          ;

            config.ForType<OrderDto, SubmitCaseInfo>()
                .Ignore(d => d.Id)
                .Map(d => d.OrderID, x => x.Id)
                .Map(d => d.CaseTitle, x => x.Title)
                .Map(d => d.CaseRegister, x => x.EmployeeName)
                .Map(d => d.CaseRegisterNo, x => x.EmployeeStaffNo)
                .Map(d => d.CaseDate, x => Convert.ToDateTime(x.CreationTime))
                .Map(d => d.PhoneNumber, x => x.Contact)
                .Map(d => d.AppLicantName, x => x.FromName)
                .Map(d => d.AppLicantAge, x => x.AgeRangeCode)
                .Map(d => d.AppLicantId, x => x.LicenceNo)
                .Map(d => d.CaseAccord, x => x.Hotspot.ProvinceCode)
                .Map(d => d.CaseContent, x => x.Content)
                .Map(d => d.CaseProcessType, x => Convert.ToInt32(x.ProcessType))
                .Map(d => d.CaseIsSecrect, x => x.IsSecret)
                .Map(d => d.CaseIsVisit, x => x.ProcessType == Hotline.Share.Enums.Order.EProcessType.Zhiban ? "0" : "1")
                .Map(d => d.EventDate, x => x.IncidentTime == null ? null : x.IncidentTime.Value.ToString("yyyy-MM-dd HH:mm:ss"))
                .Map(d => d.PushType, x => x.PushTypeCode)
              ;

            config.ForType<OrderFlowDto, SubmitCaseProcess>()
            .Map(d => d.DeptName, x => x.WorkflowTrace.OrgName)
            //.Map(d => d.TacheName, x => x.WorkflowTrace.OrgName)
            .Map(d => d.ProcessTime, x => x.WorkflowTrace.CompleteTime == null ? null : x.WorkflowTrace.CompleteTime.Value.ToString("yyyy-MM-dd HH:mm:ss"))
            .Map(d => d.ProcessName, x => x.WorkflowTrace.UserName)
            .Map(d => d.ProcessNote, x => x.WorkflowTrace.Opinion)
            .Map(d => d.EndAreaCode, x => x.WorkflowTrace.OrgAreaCode)
            .Map(d => d.EndAreaName, x => x.WorkflowTrace.OrgName)//还缺这个字段
            .Map(d => d.CaseId, x => x.WorkflowTrace.Id)
              ;

        }
    }
}
